=== debian/changelog ===
barrier (2.3.3+dfsg-1.1) unstable; urgency=medium

  * Non maintainer upload.
  * lib/ipc: Introduce writef_void(void*, ...) to fix ambiguity with
    writef(barrier::IStream*, ...) and thus fix FTBFS
    (Closes: #970611)

 -- Balint Reczey <rbalint@ubuntu.com>  Thu, 22 Oct 2020 22:09:11 +0200

barrier (2.3.3+dfsg-1) unstable; urgency=medium

  * New upstream version 2.3.3+dfsg.
    - Fix infinite loop on fast TCP disconnection (Closes: #948214)
    - Fix incorrect name of user conf file in barriers.1 (Closes: #939195)
  * d/p/use-system-gtest.patch: Update paths to use system gmock and gtest.
  * d/control, d/copyright: Update my email address.
  * d/control: Bump DH compat to 13.
  * Update Standards-Version to 4.5.0.

 -- Unit 193 <unit193@debian.org>  Tue, 21 Jul 2020 06:18:52 -0400
