=== debian/control ===
Source: barrier
Section: x11
Priority: optional
Maintainer: Unit 193 <unit193@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libavahi-compat-libdnssd-dev,
 libcurl4-openssl-dev | libcurl-dev,
 libgtest-dev,
 libice-dev,
 libsm-dev,
 libssl-dev,
 libxi-dev,
 libxinerama-dev,
 libxrandr-dev,
 libxtst-dev,
 qtbase5-dev
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://github.com/debauchee/barrier/
Vcs-Browser: https://git.unit193.net/cgit/users/unit193/barrier.git
Vcs-Git: https://git.unit193.net/cgit/users/unit193/barrier.git

Package: barrier
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, openssl
Description: Share mouse, keyboard and clipboard over the network
 Barrier lets you easily share a single mouse and keyboard between
 multiple computers with different operating systems, each with its
 own display, without special hardware.  It's intended for users
 with multiple computers on their desk since each system uses its
 own display.
 .
 Redirecting the mouse and keyboard is as simple as moving the mouse
 off the edge of your screen.  Barrier also merges the clipboards of
 all the systems into one, allowing cut-and-paste between systems.
 Furthermore, it synchronizes screen savers so they all start and stop
 together and, if screen locking is enabled, only one screen requires
 a password to unlock them all.
