=== debian/watch ===
version=3
opts="dversionmangle=s/\+dfsg$//,repacksuffix=+dfsg" \
https://github.com/debauchee/barrier/releases .*/v?([\d\.]+)\.tar\.(?:bz2|gz|xz)
