## barrier 2.4.0%2Bdfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,8 @@
 
 option (BARRIER_BUILD_GUI "Build the GUI" ON)
 option (BARRIER_BUILD_INSTALLER "Build the installer" ON)
+option (BARRIER_BUILD_TESTS "Build the tests" ON)
+option (BARRIER_USE_EXTERNAL_GTEST "Use external installation of Google Test framework" OFF)
 
 set (CMAKE_EXPORT_COMPILE_COMMANDS ON)
 set (CMAKE_CXX_STANDARD 14)
@@ -49,7 +51,6 @@
 endif()
 
 set (libs)
-include_directories (BEFORE SYSTEM ./ext/gtest/include)
 
 if (UNIX)
     if (NOT APPLE)
@@ -90,7 +91,6 @@
     check_function_exists (poll HAVE_POLL)
     check_function_exists (sigwait HAVE_POSIX_SIGWAIT)
     check_function_exists (strftime HAVE_STRFTIME)
-    check_function_exists (vsnprintf HAVE_VSNPRINTF)
     check_function_exists (inet_aton HAVE_INET_ATON)
 
     # For some reason, the check_function_exists macro doesn't detect
@@ -165,10 +165,10 @@
             link_directories("/usr/local/lib")
         endif()
 
-	if (${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
-		set (CMAKE_REQUIRED_INCLUDES "${CMAKE_REQUIRED_INCLUDES};/usr/X11R6/include;/usr/local/include;/usr/local/include/avahi-compat-libdns_sd")
+        if (${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
+            set (CMAKE_REQUIRED_INCLUDES "${CMAKE_REQUIRED_INCLUDES};/usr/X11R6/include;/usr/local/include;/usr/local/include/avahi-compat-libdns_sd")
             set (CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -L/usr/local/lib -L/usr/X11R6/lib")
-	    include_directories("/usr/local/include" "/usr/X11R6/include" "/usr/local/include/avahi-compat-libdns_sd")
+            include_directories("/usr/local/include" "/usr/X11R6/include" "/usr/local/include/avahi-compat-libdns_sd")
             link_directories("/usr/local/lib")
             link_directories("/usr/X11R6/lib")
         endif()
@@ -194,9 +194,8 @@
         check_include_files ("X11/extensions/XInput2.h" HAVE_XI2)
         check_include_files ("dns_sd.h" HAVE_DNSSD)
 
-        if (HAVE_X11_EXTENSIONS_DPMS_H)
-            # Assume that function prototypes declared, when include exists.
-            set (HAVE_DPMS_PROTOTYPES 1)
+        if (NOT HAVE_X11_EXTENSIONS_XTEST_H)
+            message (FATAL_ERROR "Missing header: X11/extensions/XTest.h")
         endif()
 
         if (NOT HAVE_X11_XKBLIB_H)
@@ -292,6 +291,9 @@
     list (APPEND libs Wtsapi32 Userenv Wininet comsuppw Shlwapi)
 
     add_definitions (
+        /DSYSAPI_WIN32=1
+        /DWINAPI_MSWINDOWS=1
+        /D_SILENCE_TR1_NAMESPACE_DEPRECATION_WARNING=1  # tr1 is used from gtest and gmock
         /DWIN32
         /D_WINDOWS
         /D_CRT_SECURE_NO_WARNINGS
@@ -300,6 +302,8 @@
     )
 endif()
 
+include_directories("${CMAKE_SOURCE_DIR}/ext/gulrak-filesystem/include")
+
 #
 # OpenSSL
 #
@@ -317,22 +321,13 @@
         ${OPENSSL_ROOT}/lib/ssleay32.lib
     )
 elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+    find_program(APT_PROGRAM "apt")
     find_program(BREW_PROGRAM "brew")
     find_program(PORT_PROGRAM "port")
-    
-    if (IS_DIRECTORY /opt/local AND PORT_PROGRAM)
-        # macports
-        set (OPENSSL_ROOT /opt/local)
-
-        set (OPENSSL_LIBS
-            ${OPENSSL_ROOT}/lib/libssl.a
-            ${OPENSSL_ROOT}/lib/libcrypto.a
-            z
-        )
-    elseif (IS_DIRECTORY /usr/local/opt/openssl AND BREW_PROGRAM)
-        # brew
-        set (OPENSSL_ROOT /usr/local/opt/openssl)
+
+    if (IS_DIRECTORY /opt/procursus AND APT_PROGRAM)
+        # procursus/apt
+        set (OPENSSL_ROOT /opt/procursus)
 
         include_directories (BEFORE SYSTEM ${OPENSSL_ROOT}/include)
 
-        set (OPENSSL_LIBS
